"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.Area = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), vutils_1 = require("@visactor/vutils"), enums_1 = require("./enums");

class Area extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.area, id);
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.area;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    setDefaultCrosshair() {
        return {
            x: {
                crosshairShape: "line"
            }
        };
    }
    setDefaultTooltip() {
        var _a, _b;
        const encodeX = null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.x, encodeY = null === (_b = this.spec.encode) || void 0 === _b ? void 0 : _b.y;
        return {
            disableGraphicTooltip: !0,
            title: (0, vutils_1.isArray)(encodeX) ? encodeX[0] : encodeX,
            content: (0, vutils_1.isArray)(encodeY) ? encodeY.map((entry => ({
                value: entry
            }))) : [ {
                value: encodeY
            } ]
        };
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d, _e, _f;
        const markEncoder = this.convertSimpleMarkEncode(encode);
        let res;
        if ((0, vutils_1.isArray)(null === (_a = markEncoder.x) || void 0 === _a ? void 0 : _a.field)) res = {
            y: markEncoder.y,
            x: {
                field: markEncoder.x.field[0],
                scale: markEncoder.x.scale
            },
            x1: {
                field: markEncoder.x.field[1],
                scale: markEncoder.x.scale
            }
        }; else if ((0, vutils_1.isArray)(null === (_b = markEncoder.y) || void 0 === _b ? void 0 : _b.field)) res = {
            y: {
                field: markEncoder.y.field[0],
                scale: markEncoder.y.scale
            },
            y1: {
                field: markEncoder.y.field[1],
                scale: markEncoder.y.scale
            },
            x: markEncoder.x
        }; else {
            const scaleYId = this.getScaleId("y");
            res = {
                x: markEncoder.x,
                y: markEncoder.y,
                y1: (datum, el, params) => {
                    const scale = params[scaleYId], domain = scale.domain(), min = (0, vutils_1.minInArray)(domain), max = (0, 
                    vutils_1.maxInArray)(domain), baseValue = min > 0 ? min : max < 0 ? max : 0;
                    return scale.scale(baseValue);
                }
            };
        }
        return markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_c = markEncoder.color) && void 0 !== _c ? _c : markEncoder.group : res.fill = null !== (_e = null === (_d = this.spec.style) || void 0 === _d ? void 0 : _d.fill) && void 0 !== _e ? _e : null === (_f = this.getPalette()) || void 0 === _f ? void 0 : _f[0], 
        res;
    }
}

exports.Area = Area, Area.type = enums_1.PlotMakType.area;